﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    class Program
    {

        /// 方法一
        static void FirstMethod(string Test)
        {
            Console.WriteLine("方法一已经执行完成!");
        }

        /// <summary>
        /// 方法二
        /// </summary>
        /// <param name="Test"></param>
        static void SecondMethod(string Test)
        {
            Console.WriteLine("方法二已经执行完成!");
        }

        /// <summary>
        /// 声明一个委托,用于实现多播操作
        /// </summary>
        /// <param name="Test"></param>
        delegate void MyMulticastDelegate(string Test);



        static void Main(string[] args)
        {
            ///首先创建一个委托指向FirstMethod方法
            MyMulticastDelegate MyFirst = new MyMulticastDelegate(FirstMethod);

            ///然后创建一个委托指向SecondMethod方法
            MyMulticastDelegate MySecond = new MyMulticastDelegate(SecondMethod);

            ////将这两个方法合并到一个多播委托中
            MyMulticastDelegate multicastDelegate = MyFirst;

            //在多播委托的调用链中添加新的委托元素

            multicastDelegate = multicastDelegate + MySecond;



            //调用多播委托,并且序列执行两个委托所指向的方法

            multicastDelegate("Test");

            Console.Read();

        }
    }
}
